"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var util_1 = require("../util");
var definition_1 = require("../definition");
var application_action_builder_1 = require("../component/application/application-action.builder");
var base_effects_1 = require("../store/effects/base.effects");
var action_1 = require("../action");
var permissions_action_builder_1 = require("../permissions/permissions-action.builder");
var transport_action_builder_1 = require("../transport/transport-action.builder");
var user_1 = require("../user");
var UniversalApplicationEffects = /** @class */ (function (_super) {
    __extends(UniversalApplicationEffects, _super);
    function UniversalApplicationEffects() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UniversalApplicationEffects_1 = UniversalApplicationEffects;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<IEffectsAction[]> | IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onInit = function () {
        return __awaiter(this, void 0, void 0, function () {
            var token, actions, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.settings.authorization.isAuthorizationNeeded === false) {
                            return [2 /*return*/, [
                                    application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction(),
                                    application_action_builder_1.ApplicationActionBuilder.buildAfterInitAction()
                                ]];
                        }
                        return [4 /*yield*/, this.notVersionedPersistentStorage.get(this.authTokenKeyName)];
                    case 1:
                        token = _a.sent();
                        actions = [];
                        if (token) {
                            actions.push(application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction({ token: token }));
                            actions.push(transport_action_builder_1.TransportActionBuilder.buildUpdateTokenAction({ token: token }));
                        }
                        result = actions.concat(application_action_builder_1.ApplicationActionBuilder.buildAfterInitAction());
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onInit] The actions are: " + JSON.stringify(result);
                        });
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     * @param {IEffectsAction} _
     * @returns {Promise<IEffectsAction[]>}
     */
    UniversalApplicationEffects.prototype.$onAfterInit = function (_) {
        return __awaiter(this, void 0, void 0, function () {
            var isAppAuthorized, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        isAppAuthorized = this.auth.isAuthorized();
                        result = [
                            isAppAuthorized
                                ? application_action_builder_1.ApplicationActionBuilder.buildPrepareAction()
                                : application_action_builder_1.ApplicationActionBuilder.buildReadyAction()
                        ];
                        return [4 /*yield*/, this.versionProcessor.processNewVersionUuidAndGetResult()];
                    case 1:
                        if ((_a.sent()) && isAppAuthorized) {
                            result.push(action_1.RouterActionBuilder.buildRewriteAction(this.routes.home));
                            util_1.ifNotEmptyThanValue(this.settings.messages.NEW_APP_VERSION_HAS_BEEN_DEPLOYED, function (message) { return result.push(action_1.NotificationActionBuilder.buildInfoAction(message)); });
                        }
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onAfterInit] The result is: " + JSON.stringify(result);
                        });
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * @stable [13.11.2019]
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onPrepare = function (action, state) {
        return application_action_builder_1.ApplicationActionBuilder.buildReadyAction();
    };
    /**
     * @stable [18.11.2019]
     * @param {IEffectsAction} action
     * @returns {IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onPrepareError = function (action) {
        return util_1.orNull(this.responseAccessor.isAuthError(action.error), function () { return (
        /**
         * We should show the login page instead of error page, therefore we clear an auth error before
         * page rendering.
         */
        application_action_builder_1.ApplicationActionBuilder.buildReadyAction()); });
    };
    /**
     * @stable [26.09.2019]
     * @returns {IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onAfterLogin = function () {
        return [
            application_action_builder_1.ApplicationActionBuilder.buildNotReadyAction(),
            application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction(),
            application_action_builder_1.ApplicationActionBuilder.buildPrepareAction(),
            action_1.RouterActionBuilder.buildNavigateAction(this.routes.home) // Need to replace "/logout"
        ];
    };
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onLogout = function () {
        return [
            permissions_action_builder_1.PermissionsActionBuilder.buildDestroyAction(),
            user_1.userActionBuilder.buildDestroyAction(),
            action_1.DictionariesActionBuilder.buildDestroyAllAction(),
            application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedAction(),
            application_action_builder_1.ApplicationActionBuilder.buildAfterLogoutAction()
        ];
    };
    /**
     * @stable [17.11.2019]
     * @returns {Promise<IEffectsAction[]>}
     */
    UniversalApplicationEffects.prototype.$onAfterLogout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _b = (_a = [
                            transport_action_builder_1.TransportActionBuilder.buildDestroyTokenAction()
                        ]).concat;
                        _c = [util_1.ifNotEmptyThanValue(this.settings.messages.logoutNotificationMessage, function (logoutNotificationMessage) { return [action_1.NotificationActionBuilder.buildInfoAction(logoutNotificationMessage)]; }, [])];
                        return [4 /*yield*/, this.checkIfNewVersionThenReload()];
                    case 1: return [2 /*return*/, _b.apply(_a, _c.concat([_d.sent()]))];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     * @param {IEffectsAction} action
     * @param {IUniversalStoreEntity} state
     * @returns {Promise<void>}
     */
    UniversalApplicationEffects.prototype.$onAuthorized = function (action, state) {
        return __awaiter(this, void 0, void 0, function () {
            var token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        token = util_1.selectToken(action.data) || util_1.selectTransportWrapperToken(state);
                        return [4 /*yield*/, this.notVersionedPersistentStorage.set(this.authTokenKeyName, token)];
                    case 1:
                        _a.sent();
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onAuthorized] The storage token has been applied: " + token;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     */
    UniversalApplicationEffects.prototype.$onUnauthorized = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.notVersionedPersistentStorage.remove(this.authTokenKeyName)];
                    case 1:
                        _a.sent();
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onUnauthorized] The storage token has been destroyed.";
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     * @returns {Promise<IEffectsAction[]>}
     */
    UniversalApplicationEffects.prototype.checkIfNewVersionThenReload = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.versionProcessor.processNewVersionUuidAndGetResult()];
                    case 1:
                        if (_a.sent()) {
                            return [2 /*return*/, [action_1.RouterActionBuilder.buildReloadAction()]];
                        }
                        return [2 /*return*/, []];
                }
            });
        });
    };
    Object.defineProperty(UniversalApplicationEffects.prototype, "authTokenKeyName", {
        /**
         * @stable [17.11.2019]
         * @returns {string}
         */
        get: function () {
            return this.settings.storage.authTokenKeyName;
        },
        enumerable: true,
        configurable: true
    });
    var UniversalApplicationEffects_1;
    UniversalApplicationEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UniversalApplicationEffects');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Auth),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "auth", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.NotVersionedPersistentStorage),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "notVersionedPersistentStorage", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Routes),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "routes", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "settings", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportResponseAccessor),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "responseAccessor", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.VersionProcessor),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "versionProcessor", void 0);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildInitActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onInit", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterInitActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onAfterInit", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_APPLICATION_PREPARE_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onPrepare", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_APPLICATION_PREPARE_ERROR_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onPrepareError", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterLoginActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], UniversalApplicationEffects.prototype, "$onAfterLogin", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildLogoutActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], UniversalApplicationEffects.prototype, "$onLogout", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterLogoutActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onAfterLogout", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAuthorizedActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onAuthorized", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onUnauthorized", null);
    UniversalApplicationEffects = UniversalApplicationEffects_1 = __decorate([
        inversify_1.injectable()
    ], UniversalApplicationEffects);
    return UniversalApplicationEffects;
}(base_effects_1.BaseEffects));
exports.UniversalApplicationEffects = UniversalApplicationEffects;
//# sourceMappingURL=universal-application.effects.js.map