import { CompositeCronFieldItemsEnum, CompositeCronFieldPropsT, ICompositeCronFieldConfigEntity, ICompositeCronFieldItemEntity } from '../../../definition';
import { ControlledFieldFactory } from '../controlled-field-factory.service';
export declare class CompositeCronFieldFactory extends ControlledFieldFactory<ICompositeCronFieldConfigEntity, ICompositeCronFieldItemEntity, CompositeCronFieldItemsEnum> {
    private static readonly DEFAULT_FIELDS;
    private readonly dc;
    /**
     * @stable [18.12.2019]
     */
    constructor();
    /**
     * @stable [18.12.2019]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {ICompositeCronFieldItemEntity[]}
     */
    protected getFields(config: ICompositeCronFieldConfigEntity): ICompositeCronFieldItemEntity[];
    /**
     * @stable [18.12.2019]
     * @param {ICompositeCronFieldConfigEntity} config
     * @param {ICompositeCronFieldItemEntity} actualFieldCfg
     * @param {ICompositeCronFieldItemEntity[]} actualFields
     * @returns {CompositeCronFieldPropsT}
     */
    protected getExtraProps(config: ICompositeCronFieldConfigEntity, actualFieldCfg: ICompositeCronFieldItemEntity, actualFields: ICompositeCronFieldItemEntity[]): CompositeCronFieldPropsT;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @param {DateTimeLikeTypeT} fromDateValue
     * @param {StringNumberT} currentCronPeriod
     */
    private onCompositeFieldChange;
    /**
     * @stable [18.12.2019]
     * @param {DateTimeLikeTypeT} fromDateValue
     * @param {boolean} applyYear
     * @returns {string}
     */
    private asCronEntity;
    /**
     * @stable [18.12.2019]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {ICompositeCronFieldItemEntity}
     */
    private getCronFieldItem;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {ICompositeCronFieldItemEntity}
     */
    private getDateFromFieldItem;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {ICompositeCronFieldItemEntity}
     */
    private getPeriodFieldItem;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldItemEntity} fieldItem
     * @returns {string}
     */
    private getFieldName;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {string}
     */
    private getDateFromFieldName;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {string}
     */
    private getCronFieldName;
    /**
     * @stable [13.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {string}
     */
    private getPeriodFieldName;
    /**
     * @stable [12.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {IEntity}
     */
    private asContainerEntity;
    /**
     * @stable [13.01.2020]
     * @param {ICompositeCronFieldConfigEntity} config
     * @returns {CronPeriodsEnum}
     */
    private getPeriodValue;
}
