"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var field_1 = require("../../field");
var util_1 = require("../../../util");
var BaseCheckbox = /** @class */ (function (_super) {
    __extends(BaseCheckbox, _super);
    function BaseCheckbox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [31.08.2018]
     * @returns {IBaseCheckboxInputProps}
     */
    BaseCheckbox.prototype.getInputElementProps = function () {
        return __assign({}, _super.prototype.getInputElementProps.call(this), { type: 'checkbox', 
            /**
             * Needed for entity initialization
             * @stable [17.08.2018]
             */
            checked: this.displayValue, 
            /**
             * Only the manual changes
             * @stable [17.08.2018]
             */
            onChange: util_1.noop });
    };
    /**
     * @stable [23.10.2019]
     * @param {IBaseEvent} event
     */
    BaseCheckbox.prototype.onClick = function (event) {
        this.onChangeManually(!this.value);
        _super.prototype.onClick.call(this, event);
    };
    /**
     * @stable [24.10.2019]
     * @returns {string}
     */
    BaseCheckbox.prototype.getFieldClassName = function () {
        return util_1.joinClassName(_super.prototype.getFieldClassName.call(this), 'rac-base-checkbox', this.value ? 'rac-checked' : 'rac-unchecked');
    };
    /**
     * @stable [16.01.2020]
     * @returns {string}
     */
    BaseCheckbox.prototype.getLabel = function () {
        return this.value
            ? _super.prototype.getLabel.call(this)
            : util_1.nvl(this.props.disableLabel, _super.prototype.getLabel.call(this));
    };
    return BaseCheckbox;
}(field_1.Field));
exports.BaseCheckbox = BaseCheckbox;
//# sourceMappingURL=base-checkbox.component.js.map