import { EntityIdT, IKeyboardEvent, AnyT } from '../../../definitions.interface';
import { BaseSelect } from '../../field/select';
import { IMultiFieldState, IMultiFieldProps, IMultiField } from './multifield.interface';
import { MultiFieldPlugin } from './multifield.plugin';
import { IMultiItemEntity, ISelectOptionEntity } from '../../../definition';
export declare class MultiField<TProps extends IMultiFieldProps, TState extends IMultiFieldState> extends BaseSelect<TProps, TState> implements IMultiField {
    /**
     * @stable [01.06.2018]
     */
    static defaultProps: IMultiFieldProps;
    multiFieldPlugin: MultiFieldPlugin;
    /**
     * @stable [01.06.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyBackspace(event: IKeyboardEvent): void;
    /**
     * @stable [19.11.2018]
     * @param {IMultiItemEntity} item
     */
    addItem(item: IMultiItemEntity): void;
    /**
     * @stable [19.08.2018]
     * @param {IMultiItemEntity} item
     */
    deleteItem(item: IMultiItemEntity): void;
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    editItem(item: IMultiItemEntity): void;
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    mergeItem(item: IMultiItemEntity): void;
    /**
     * @stable [01.06.2018]
     * @returns {EntityIdT[]}
     */
    protected readonly originalEmptyValue: EntityIdT[];
    /**
     * @stable [11.08.2018]
     * @param {ISelectOptionEntity} option
     */
    protected onSelect(option: ISelectOptionEntity): void;
    /**
     * @stable [01.06.2018]
     * @param {IMultiItemEntity} item
     */
    protected onDelete(item: IMultiItemEntity): void;
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    protected onEdit(item: IMultiItemEntity): void;
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    protected onMerge(item: IMultiItemEntity): void;
    /**
     * @stable [19.06.2018]
     * @param {ISelectOptionEntity[]} options
     * @returns {ISelectOptionEntity[]}
     */
    protected getFilteredOptions(): ISelectOptionEntity[];
    /**
     * @stable [21.09.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [14.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    protected decorateDisplayValue(value: AnyT): string;
}
