import { IFieldProps } from '../../configurations-definitions.interface';
import { IFormProps, ITabProps } from '../../definition';
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @param {IFieldProps} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldDisabled: (formProps: IFormProps<import("core/definitions.interface").IEntity>, fieldProps: IFieldProps) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @param {IFieldProps} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldChangeable: (formProps: IFormProps<import("core/definitions.interface").IEntity>, fieldProps: IFieldProps) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormChangeable: (formProps: IFormProps<import("core/definitions.interface").IEntity>) => boolean;
/**
 * @stable [15.02.2019]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormResettable: (formProps: IFormProps<import("core/definitions.interface").IEntity>) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IFormProps} formProps
 * @param {IGenericTabEntity} tab
 * @returns {boolean}
 */
export declare const isFormTabActive: (formProps: IFormProps<import("core/definitions.interface").IEntity>, tab: ITabProps) => boolean;
