/// <reference types="react" />
import { BaseComponent } from '../base/base.component';
import { IHeaderProps } from '../../definition';
export declare class Header extends BaseComponent<IHeaderProps> {
    private readonly defaultMenuProps;
    private readonly defaultMenuActionProps;
    private readonly menuAnchorRef;
    private readonly menuRef;
    /**
     * @stable [06.02.2020]
     * @param {IHeaderProps} props
     */
    constructor(props: IHeaderProps);
    /**
     * @stable [06.02.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [12.02.2020]
     * @returns {React.ReactNode}
     */
    private readonly headerContentElement;
    /**
     * @stable [06.02.2020]
     * @returns {JSX.Element}
     */
    private readonly menuActionElement;
    /**
     * @stable [06.02.2020]
     * @param {IMenuItemEntity} menuItem
     */
    private onMenuItemSelect;
    /**
     * @stable [06.02.2020]
     */
    private onMenuActionClick;
    /**
     * @stable [06.02.2020]
     * @returns {HTMLElement}
     */
    private getMenuAnchorElement;
    /**
     * @stable [12.02.2020]
     * @returns {boolean}
     */
    private readonly isBackActionRendered;
}
