"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var default_layout_view_builder_1 = require("./default-layout-view.builder");
var definition_1 = require("../../../definition");
var universal_layout_builder_1 = require("./universal-layout.builder");
describe('layout.builder', function () {
    it('test1', function () {
        function pseudoElement(name, value) {
            var _a;
            this.props = (_a = {}, _a[name] = value, _a);
        }
        var layoutBuilder = new universal_layout_builder_1.UniversalLayoutBuilder(new default_layout_view_builder_1.DefaultLayoutViewBuilder());
        var layout = layoutBuilder.build({
            children: [
                new pseudoElement('p1', 'v1'),
                {
                    layout: definition_1.LayoutTypesEnum.HORIZONTAL,
                    children: [
                        new pseudoElement('p2', 'v2'),
                        {
                            factor: definition_1.LayoutFactorsEnum.FACTOR_2,
                            children: [
                                new pseudoElement('p4', 'v4'),
                                new pseudoElement('p5', 'v5')
                            ],
                        },
                        new pseudoElement('p3', 'v3')
                    ],
                }
            ],
        });
        expect(layout).toEqual({
            rows: [
                new pseudoElement('p1', 'v1'),
                {
                    columns: [
                        new pseudoElement('p2', 'v2'),
                        {
                            factor: definition_1.LayoutFactorsEnum.FACTOR_2,
                            rows: [
                                new pseudoElement('p4', 'v4'),
                                new pseudoElement('p5', 'v5')
                            ],
                        },
                        new pseudoElement('p3', 'v3')
                    ],
                }
            ],
        });
    });
});
//# sourceMappingURL=layout.builder.spec.js.map