/// <reference types="react" />
import { INavigationListProps } from './navigation-list.interface';
import { UniversalComponent } from '../../base/universal.component';
export declare class NavigationList extends UniversalComponent<INavigationListProps> {
    /**
     * @stable [24.10.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [07.02.2020]
     * @param {string} key
     * @returns {JSX.Element}
     */
    private getListDividerElement;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {JSX.Element}
     */
    private toElement;
    /**
     * @stable [12.02.2020]
     * @param {INavigationItemEntity} item
     * @returns {JSX.Element}
     */
    private asItemElement;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} config
     */
    private onGroupLinkClick;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {boolean}
     */
    private isItemExpanded;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly isFullLayoutModeEnabled;
    private readonly layoutMode;
    /**
     * @stable [04.02.2020]
     * @returns {LayoutModesEnum}
     */
    private readonly systemLayoutMode;
    /**
     * @stable [04.02.2020]
     * @returns {IDefaultLayoutProps}
     */
    private readonly systemSettings;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {boolean}
     */
    private hasActiveChild;
    /**
     * @stable [07.02.2020]
     * @param {boolean} isGroup
     * @param {boolean} isActive
     * @param {boolean} isExpanded
     * @returns {string}
     */
    private buildItemClassNames;
    /**
     * @stable [07.02.2020]
     * @param {string} link
     * @param {string} prefix
     * @returns {string}
     */
    private asUniqueKey;
}
