import { IComponent, IStickyComponentProps, IUniversalPlugin } from '../../definition';
export declare class StickyHeaderPlugin implements IUniversalPlugin {
    private readonly component;
    private readonly domAccessor;
    private readonly eventManager;
    private resizeUnsubscriber;
    private scrollUnsubscriber;
    private isStickyElementMounted;
    /**
     * @stable [06.02.2020]
     * @param {IComponent<IStickyComponentProps>} component
     */
    constructor(component: IComponent<IStickyComponentProps>);
    /**
     * @stable [11.10.2019]
     */
    componentDidMount(): void;
    /**
     * @stable [11.10.2019]
     */
    componentDidUpdate(): void;
    /**
     * @stable [11.10.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [11.10.2019]
     */
    private doSetStickyElementProperties;
    /**
     * @stable [16.10.2019]
     */
    private checkStickyElement;
    /**
     * @stable [16.10.2019]
     */
    private clearAllListeners;
    /**
     * @stable [16.10.2019]
     * @returns {string}
     */
    private readonly stickySelector;
}
