import { Store, AnyAction } from 'redux';
import { IDispatcher, IUniversalContainer, IUniversalContainerProps, IUniversalStoreEntity } from '../../../definition';
import { IKeyValue } from '../../../definitions.interface';
export declare class BaseStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> implements IDispatcher {
    protected readonly container: IUniversalContainer<TProps>;
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IUniversalContainer<TProps>);
    /**
     * @stable [03.10.2019]
     * @param {string} type
     * @param {TChanges} data
     */
    dispatch<TChanges = IKeyValue>(type: string, data?: TChanges): void;
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TData} data
     */
    dispatchCustomType<TData = IKeyValue>(type: string, data?: TData): void;
    /**
     * @stable [11.09.2019]
     * @param {AnyAction} action
     */
    dispatchAnyAction(action: AnyAction): void;
    /**
     * @reactNativeCompatible
     * @stable [11.09.2019]
     * @returns {Store<TStore>}
     */
    protected readonly appStore: Store<TStore>;
    /**
     * @stable [11.09.2019]
     * @returns {string}
     */
    protected readonly sectionName: string;
    /**
     * @stable [11.09.2019]
     * @returns {TProps}
     */
    protected readonly props: TProps;
}
