"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../base");
var button_1 = require("../button");
var flex_1 = require("../layout/flex");
var definition_1 = require("../../definition");
var util_1 = require("../../util");
var toolbar_tools_interface_1 = require("./toolbar-tools.interface");
var ToolbarToolsContainer = /** @class */ (function (_super) {
    __extends(ToolbarToolsContainer, _super);
    function ToolbarToolsContainer() {
        var _a;
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultActions = (_a = {},
            _a[definition_1.ToolbarToolsEnum.FILTER] = {
                icon: 'filter',
                onClick: _this.onFilterClick.bind(_this),
            },
            _a[definition_1.ToolbarToolsEnum.DOWNLOAD_FILE] = {
                icon: 'download',
                onClick: _this.onDownloadFileClick.bind(_this),
            },
            _a[definition_1.ToolbarToolsEnum.REFRESH] = {
                icon: 'refresh',
                onClick: _this.onRefreshClick.bind(_this),
            },
            _a);
        return _this;
    }
    /**
     * @stable [10.03.2019]
     * @returns {JSX.Element}
     */
    ToolbarToolsContainer.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var _a = this.props.actions, actions = _a === void 0 ? [definition_1.ToolbarToolsEnum.REFRESH] : _a;
        return (React.createElement(flex_1.FlexLayout, __assign({ row: true, justifyContentEnd: true }, props.flex, { className: util_1.joinClassName(util_1.calc(props.className), 'rac-toolbar-tools') }),
            props.leftSlot,
            actions.map(function (cfg, index) {
                var actionProps = util_1.isPrimitive(cfg) ? _this.defaultActions[cfg] : cfg;
                return (React.createElement(button_1.Button, __assign({ key: "action-" + index + "-key", disabled: props.actionsDisabled, className: util_1.joinClassName((props.activeActions || []).includes(cfg) && 'rac-toolbar-tool-active') }, actionProps)));
            }),
            props.rightSlot));
    };
    /**
     * @stable [10.03.2019]
     */
    ToolbarToolsContainer.prototype.onRefreshClick = function () {
        var props = this.props;
        if (util_1.isFn(props.onRefreshClick)) {
            props.onRefreshClick();
        }
        else {
            this.dispatchFrameworkAction(toolbar_tools_interface_1.TOOLBAR_TOOLS_REFRESH_ACTION_TYPE);
        }
    };
    /**
     * @stable [10.03.2019]
     */
    ToolbarToolsContainer.prototype.onFilterClick = function () {
        var props = this.props;
        if (util_1.isFn(props.onFilterClick)) {
            props.onFilterClick();
        }
        else {
            this.dispatchFrameworkAction(toolbar_tools_interface_1.TOOLBAR_TOOLS_FILTER_ACTION_TYPE);
        }
    };
    /**
     * @stable [16.04.2019]
     */
    ToolbarToolsContainer.prototype.onDownloadFileClick = function () {
        var props = this.props;
        if (util_1.isFn(props.onDownloadFileClick)) {
            props.onDownloadFileClick();
        }
        else {
            this.dispatchFrameworkAction(toolbar_tools_interface_1.TOOLBAR_TOOLS_DOWNLOAD_FILE_ACTION_TYPE);
        }
    };
    return ToolbarToolsContainer;
}(base_1.BaseContainer));
exports.ToolbarToolsContainer = ToolbarToolsContainer;
//# sourceMappingURL=toolbar-tools.container.js.map