"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var definitions_interface_1 = require("../../../definitions.interface");
var util_1 = require("../../../util");
var universal_component_1 = require("../../base/universal.component");
var UniversalPageToolbar = /** @class */ (function (_super) {
    __extends(UniversalPageToolbar, _super);
    function UniversalPageToolbar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    UniversalPageToolbar.prototype.checkAndGetControls = function () {
        return util_1.orNull(!(this.isPreviousBtnDisabled && this.isNextBtnDisabled), this.getControls());
    };
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    UniversalPageToolbar.prototype.getToolbarBody = function () {
        var props = this.props;
        return props.totalCount > 0 && !props.progress
            ? this.getContent()
            : this.getDefaultContent();
    };
    /**
     * @stable [21.09.2018]
     * @returns {boolean}
     */
    UniversalPageToolbar.prototype.isToolbarVisible = function () {
        var props = this.props;
        return props.totalCount > props.pageSize;
    };
    Object.defineProperty(UniversalPageToolbar.prototype, "isPreviousBtnDisabled", {
        /**
         * @stable [16.05.2018]
         * @returns {boolean}
         */
        get: function () {
            return this.props.page === definitions_interface_1.FIRST_PAGE;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalPageToolbar.prototype, "isNextBtnDisabled", {
        /**
         * @stable [16.05.2018]
         * @returns {boolean}
         */
        get: function () {
            return this.toNumber === this.props.totalCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalPageToolbar.prototype, "toNumber", {
        /**
         * @stable [16.05.2018]
         * @returns {number}
         */
        get: function () {
            return util_1.pageToNumber(this.props);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalPageToolbar.prototype, "fromNumber", {
        /**
         * @stable [16.05.2018]
         * @returns {number}
         */
        get: function () {
            return util_1.pageFromNumber(this.props);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalPageToolbar.prototype, "pagesLabel", {
        /**
         * @stable [23.06.2018]
         * @returns {string}
         */
        get: function () {
            var _a = this.props, useSimplePagesFormat = _a.useSimplePagesFormat, page = _a.page;
            var messages = this.settings.messages;
            return useSimplePagesFormat
                ? messages.simplePagesMessage
                    .replace('{page}', "" + page)
                    .replace('{count}', "" + util_1.pagesCount(this.props))
                : messages.pagesMessage
                    .replace('{from}', "" + this.fromNumber)
                    .replace('{to}', "" + this.toNumber)
                    .replace('{count}', "" + this.props.totalCount);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    UniversalPageToolbar.prototype.getDefaultContent = function () {
        return null;
    };
    return UniversalPageToolbar;
}(universal_component_1.UniversalComponent));
exports.UniversalPageToolbar = UniversalPageToolbar;
//# sourceMappingURL=universal-page-toolbar.component.js.map