import { AnyT } from '../../../definitions.interface';
import { IUniversalPdfPlugin } from './pdf-viewer.interface';
export declare class UniversalPdfPlugin implements IUniversalPdfPlugin {
    private workerSrc;
    private canvasResolver;
    private onSuccess?;
    private onError?;
    private static logger;
    private page;
    private scale;
    private src;
    private loadTask;
    private loadPageTask;
    private loadedDocument;
    /**
     * @stable [14.11.2018]
     * @param {string} workerSrc
     * @param {() => HTMLCanvasElement} canvasResolver
     * @param {() => void} onSuccess
     * @param {(error: AnyT) => void} onError
     */
    constructor(workerSrc: string, canvasResolver: () => HTMLCanvasElement, onSuccess?: () => void, onError?: (error: AnyT) => void);
    /**
     * @stable [14.11.2018]
     * @param {number} page
     * @returns {IUniversalPdfPlugin}
     */
    setPage(page: number): IUniversalPdfPlugin;
    /**
     * @stable [14.11.2018]
     * @param {string} src
     * @returns {IUniversalPdfPlugin}
     */
    setSrc(src: string): IUniversalPdfPlugin;
    /**
     * @stable [14.11.2018]
     * @param {number} scale
     * @returns {IUniversalPdfPlugin}
     */
    setScale(scale: number): IUniversalPdfPlugin;
    /**
     * @stable [14.11.2018]
     */
    loadDocument(): void;
    /**
     * @stable [14.11.2018]
     */
    refreshPage(): void;
    /**
     * @stable [14.11.2018]
     * @returns {boolean}
     */
    readonly hasLoadedDocument: boolean;
    readonly numPages: number;
    /**
     * @stable [14.11.2018]
     */
    cancel(): void;
    /**
     * @stable [14.11.2018]
     * @param {IPdfViewerDocument} pdf
     * @returns {IPdfViewerDocument}
     */
    private onLoad;
    /**
     * @stable [14.11.2018]
     * @param {IPdfViewerPage} page
     * @returns {IPdfViewerPage}
     */
    private onLoadPage;
    /**
     * @stable [14.11.2018]
     * @param {AnyT} error
     * @returns {AnyT}
     */
    private onLoadError;
    /**
     * @stable [14.11.2018]
     */
    private cancelTask;
    /**
     * @stable [14.11.2018]
     */
    private cancelPageTask;
    /**
     * @stable [14.11.2018]
     * @returns {HTMLCanvasElement}
     */
    private readonly renderArea;
}
