/// <reference types="react" />
import { BaseComponent } from '../base';
import { IViewerProps, IViewerState } from './viewer.interface';
export declare abstract class Viewer<TProps extends IViewerProps = IViewerProps, TState extends IViewerState = IViewerState> extends BaseComponent<TProps, TState> {
    /**
     * @stable [08.07.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [08.07.2018]
     * @param {TProps} props
     * @param {TState} state
     */
    componentDidUpdate(props: TProps, state: TState): void;
    /**
     * @stable [08.07.2018]
     */
    componentDidMount(): void;
    /**
     * @stable [08.07.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [10.01.2019]
     * @returns {string}
     */
    protected getClassName(): string;
    /**
     * @stable [08.07.2018]
     */
    protected refresh(): void;
    /**
     * @stable [08.07.2018]
     * @returns {JSX.Element}
     */
    protected abstract getContentElement(): JSX.Element;
    /**
     * @stable [08.07.2018]
     * @returns {JSX.Element}
     */
    protected abstract gePreviewElement(): JSX.Element;
    /**
     * @stable [08.07.2018]
     * @returns {boolean}
     */
    protected readonly isProgressMessageShown: boolean;
    /**
     * @stable [08.07.2018]
     */
    protected onDialogClose(): void;
    /**
     * @stable [08.07.2018]
     */
    private onPreview;
}
