import { PhoneNumber as PN, PhoneNumberFormat as PNF } from 'google-libphonenumber';
import { IPhoneConfigEntity, IPhoneConverter } from '../../definition';
export declare class PhoneConverter implements IPhoneConverter<PNF> {
    private readonly settings;
    private readonly phoneUtilInstance;
    /**
     * @stable [24.12.2019]
     * @param {IPhoneConfigEntity<libphonenumber.PhoneNumberFormat>} config
     * @returns {string}
     */
    format(config: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [24.12.2019]
     * @param {IPhoneConfigEntity<libphonenumber.PhoneNumberFormat>} config
     * @returns {libphonenumber.PhoneNumber}
     */
    parse(config: IPhoneConfigEntity<PNF>): PN;
}
