import * as React from 'react';
import { IChildrenWrapper, IClassNameWrapper, IFactorWrapper, IFullWrapper, IKeyValue, ILayoutWrapper, IStyleWrapper } from '../definitions.interface';
/**
 * @enum
 * @stable [23.01.2020]
 */
export declare enum LayoutTypesEnum {
    HORIZONTAL = 0,
    VERTICAL = 1
}
/**
 * @enum
 * @stable [23.01.2020]
 */
export declare enum LayoutFactorsEnum {
    FACTOR_0_5 = 0,
    FACTOR_0_75 = 1,
    FACTOR_1 = 2,
    FACTOR_2 = 3,
    FACTOR_4 = 4,
    FACTOR_8 = 5
}
/**
 * @stable [23.01.2020]
 */
export declare type UniversalLayoutBuilderChildrenT<TNode> = IUniversalLayoutBuilderConfigEntity<TNode> | TNode;
/**
 * @stable [23.01.2020]
 */
export declare type LayoutBuilderChildrenT = UniversalLayoutBuilderChildrenT<JSX.Element>;
/**
 * @config-entity
 * @stable [23.01.2020]
 */
export interface IUniversalLayoutBuilderConfigEntity<TNode> extends IChildrenWrapper<Array<UniversalLayoutBuilderChildrenT<TNode>>>, IClassNameWrapper, IFactorWrapper<LayoutFactorsEnum>, IFullWrapper, ILayoutWrapper<LayoutTypesEnum>, IStyleWrapper<IKeyValue> {
}
/**
 * @config-entity
 * @stable [23.01.2020]
 */
export interface ILayoutBuilderConfigEntity extends IUniversalLayoutBuilderConfigEntity<LayoutBuilderChildrenT> {
}
/**
 * @props
 * @stable [23.01.2020]
 */
export interface IUniversalLayoutProps extends React.Attributes {
}
/**
 * @service
 * @stable [23.01.2020]
 */
export interface IUniversalLayoutViewBuilder<TNode, TProps extends IUniversalLayoutProps = IUniversalLayoutProps> {
    buildColumnView(props: TProps, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfigEntity<TNode>): TNode;
    buildRowView(props: TProps, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfigEntity<TNode>): TNode;
    cloneItem(item: TNode, props: TProps): TNode;
    getClonedItemProps(item: TNode, layoutConfig: IUniversalLayoutBuilderConfigEntity<TNode>, props: TProps): TProps;
    isClonedItem(item: UniversalLayoutBuilderChildrenT<TNode>): boolean;
}
/**
 * @service
 * @stable [23.01.2020]
 */
export interface ILayoutViewBuilder extends IUniversalLayoutViewBuilder<React.ReactNode, React.DetailedHTMLProps<React.HTMLAttributes<{}>, {}>> {
}
