"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var definitions_interface_1 = require("../definitions.interface");
var env_1 = require("../env");
var filter_1 = require("../util/filter");
/**
 * @stable [24.09.2019]
 */
var StorageEventCategoriesEnum;
(function (StorageEventCategoriesEnum) {
    StorageEventCategoriesEnum["STORAGE_ERROR"] = "storage:error";
})(StorageEventCategoriesEnum = exports.StorageEventCategoriesEnum || (exports.StorageEventCategoriesEnum = {}));
/**
 * @stable [24.09.2019]
 */
var StorageEventsEnum;
(function (StorageEventsEnum) {
    StorageEventsEnum["SYNC_APP_STATE"] = "sync:app:state";
})(StorageEventsEnum = exports.StorageEventsEnum || (exports.StorageEventsEnum = {}));
/**
 * @stable [16.09.2019]
 */
exports.STORAGE_PATH_SEPARATOR = '#';
exports.STORAGE_NOT_VERSIONED_KEY = filter_1.filterArray([env_1.ENV.appProfile, env_1.ENV.port, env_1.ENV.normalizedBasePath], filter_1.NOT_EMPTY_VALUE_PREDICATE).join(exports.STORAGE_PATH_SEPARATOR);
exports.STORAGE_VERSIONED_KEY = filter_1.filterArray([env_1.ENV.appVersion, exports.STORAGE_NOT_VERSIONED_KEY], filter_1.NOT_EMPTY_VALUE_PREDICATE).join(exports.STORAGE_PATH_SEPARATOR);
/**
 * @stable [17.11.2019]
 */
exports.DEFAULT_STORAGE_SETTINGS_ENTITY = Object.freeze({
    appStateKeyName: '$$rac.state.a14e44d3',
    appStateSyncEnabled: true,
    appStateSyncTimeout: 2000,
    authTokenKeyName: '$$rac.token.2e45abd2',
    versionUuidKeyName: '$$rac.uuid.acd22d11',
});
/**
 * @stable [28.07.2019]
 */
var StorageTypesEnum;
(function (StorageTypesEnum) {
    StorageTypesEnum[StorageTypesEnum["SESSION"] = 0] = "SESSION";
    StorageTypesEnum[StorageTypesEnum["LOCAL"] = 1] = "LOCAL";
})(StorageTypesEnum = exports.StorageTypesEnum || (exports.StorageTypesEnum = {}));
/**
 * @stable [17.11.2019]
 */
exports.$RAC_STORAGE_REGISTER_SYNC_APP_STATE_TASK_ACTION_TYPE = definitions_interface_1.ACTION_PREFIX + "storage.register.sync.app.state.task";
exports.$RAC_STORAGE_SYNC_APP_STATE_ACTION_TYPE = definitions_interface_1.ACTION_PREFIX + "storage.sync.app.state";
exports.$RAC_STORAGE_UNREGISTER_SYNC_APP_STATE_TASK_ACTION_TYPE = definitions_interface_1.ACTION_PREFIX + "storage.unregister.sync.app.state.task";
//# sourceMappingURL=storage-definition.interface.js.map