import { IAsyncLibrariesSettingsEntity, IComponentsSettingsEntity, ICurrencySettingsEntity, IDateTimeSettingsEntity, IGoogleMapsSettingsEntity, IMessagesSettingsEntity, IPhoneSettingsEntity, IStorageSettingsEntity, ITransportSettingsEntity, IUrlsSettingsEntity, StorageTypesEnum } from '../definition';
export interface IApplicationResourcePaths {
    uiDefaultIconPath?: string;
}
export declare enum StartDayOfWeekT {
    MONDAY = 0,
    SUNDAY = 1
}
export interface IDateTimeSettings extends IDateTimeSettingsEntity {
    startDayOfWeek?: StartDayOfWeekT;
    timeZone?: string;
    dateFormat?: string;
    timeFormat?: string;
    uiMonthFormat?: string;
    pstDateFormat?: string;
    pstTimeFormat?: string;
    uiTimeMask?: Array<string | RegExp>;
    uiShortTimeMask?: Array<string | RegExp>;
    uiTimePattern?: string;
    uiShortTimePattern?: string;
}
export interface IApplicationNumberSettings {
    uiPattern?: string;
}
/**
 * @stable [10.03.2019]
 */
export interface IMessagesSettings extends IMessagesSettingsEntity {
    acceptMessage?: string;
    accessDeniedMessage?: string;
    appNotReadyMessage?: string;
    closeMessage?: string;
    confirmationMessage?: string;
    continueMessage?: string;
    dataSaved?: string;
    dialogTitleMessage?: string;
    dndMessage?: string;
    emptyDataMessage?: string;
    emptyMessage?: string;
    errorMessage?: string;
    exportActionTitleMessage?: string;
    fileLoadErrorMessage?: string;
    invalidAddressMessage?: string;
    logoutNotificationMessage?: string;
    noAvailableItemsToSelectMessage?: string;
    noItemsMessage?: string;
    pagesMessage?: string;
    previewMessage?: string;
    refreshActionTitleMessage?: string;
    requestCancelErrorMessage?: string;
    serviceTemporarilyUnavailableMessage?: string;
    simplePagesMessage?: string;
    sorryMessage?: string;
    takeSnapshotMessage?: string;
    unknownFileMessage?: string;
    waitingMessage?: string;
    waitMessage?: string;
    welcomeMessage?: string;
    yearMessage?: string;
}
export interface IAuthorizationSettings {
    isAuthorizationNeeded?: boolean;
}
export interface IApplicationChannelSettings {
    eventToListen?: string;
    eventToEmit?: string;
}
export interface IBootstrapSettings {
    flexEnabled?: boolean;
    rootId?: string;
}
export interface ISettingsEntity {
    asyncLibraries?: IAsyncLibrariesSettingsEntity;
    authorization?: IAuthorizationSettings;
    bootstrap?: IBootstrapSettings;
    channel?: IApplicationChannelSettings;
    companyName?: string;
    components?: IComponentsSettingsEntity;
    currency?: ICurrencySettingsEntity;
    dateTime?: IDateTimeSettings;
    downloadUrl?: string;
    emptyPictureUrl?: string;
    googleMaps?: IGoogleMapsSettingsEntity;
    messages?: IMessagesSettings;
    metaFilesUrl?: string;
    number?: IApplicationNumberSettings;
    pdfWorkerDirectoryUrl?: string;
    persistenceStorage?: StorageTypesEnum;
    phone?: IPhoneSettingsEntity;
    resourcePaths?: IApplicationResourcePaths;
    signalRUrl?: string;
    storage?: IStorageSettingsEntity;
    transport?: ITransportSettingsEntity;
    urls?: IUrlsSettingsEntity;
}
export declare const DEFAULT_APPLICATION_SETTINGS: ISettingsEntity;
