import { IEntity, IEntityIdTWrapper } from '../definitions.interface';
import { IExtendedEntity, IMultiEntity } from '../definition';
/**
 * @stable [19.10.2019]
 * @param {TEntity} entity
 * @returns {boolean}
 */
export declare const isNewEntity: <TEntity extends IEntityIdTWrapper>(entity: TEntity) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IExtendedEntity<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isNewExtendedEntity: <TEntity extends IEntity>(entity: IExtendedEntity<TEntity>) => boolean;
/**
 * @stable [01.10.2019]
 * @param {IExtendedEntity<TEntity extends IEntity>} extendedEntity
 * @returns {boolean}
 */
export declare const doesExtendedEntityExist: <TEntity extends IEntity>(extendedEntity: IExtendedEntity<TEntity>) => boolean;
/**
 * @stable [30.08.2019]
 * @param {TEntity} entity
 * @returns {string}
 */
export declare const entityAsFileName: <TEntity extends IEntity>(entity: TEntity) => string;
/**
 * @stable [12.10.2019]
 * @param {MultiFieldEntityT | EntityIdT} value
 * @returns {boolean}
 */
export declare const isNotMultiEntity: (value: string | number | IEntity[] | IMultiEntity<IEntity>) => boolean;
