import { IFormProps, IGenericBaseFieldEntity } from '../definition';
import { IEntity } from '../definitions.interface';
/**
 * [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @param {IGenericBaseFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldValue: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>, fieldProps: IGenericBaseFieldEntity) => any;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @param {IGenericBaseFieldEntity} fieldProps
 * @param {IGenericBaseFieldEntity} defaultFieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldDisplayValue: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>, fieldProps: IGenericBaseFieldEntity, defaultFieldProps?: IGenericBaseFieldEntity) => any;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @param {IGenericBaseFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldOriginalValue: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>, fieldProps: IGenericBaseFieldEntity) => any;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormDisabled: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormDirty: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [16.01.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormValid: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormInProgress: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} formEntity
 * @param {IGenericBaseFieldEntity} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldReadOnly: <TEntity extends IEntity = IEntity>(formEntity: IFormProps<TEntity>, fieldProps: IGenericBaseFieldEntity) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} formProps
 * @returns {boolean}
 */
export declare const isFormSubmittable: <TEntity extends IEntity = IEntity>(formProps: IFormProps<TEntity>) => boolean;
