import { IChangesWrapper, IDataWrapper, IEntity, IEntityWrapper, IFormWrapper, ITokenWrapper } from '../definitions.interface';
/**
 * @stable [29.02.2020]
 * @param {IFormWrapper<TValue>} wrapper
 * @returns {TValue}
 */
export declare const selectForm: <TValue>(wrapper: IFormWrapper<TValue>) => TValue;
/**
 * @stable [29.02.2020]
 * @param {ITokenWrapper<TValue>} wrapper
 * @returns {TValue}
 */
export declare const selectToken: <TValue = string>(wrapper: ITokenWrapper<TValue>) => TValue;
/**
 * @stable [05.03.2020]
 * @param {IChangesWrapper<TResult>} entity
 * @returns {TResult}
 */
export declare const selectChanges: <TResult = IEntity>(entity: IChangesWrapper<TResult>) => TResult;
/**
 * @stable [05.03.2020]
 * @param {IEntityWrapper<TResult>} entity
 * @returns {TResult}
 */
export declare const selectEntity: <TResult = IEntity>(entity: IEntityWrapper<TResult>) => TResult;
/**
 * @stable [05.03.2020]
 * @param {IDataWrapper<TData>} wrapper
 * @returns {TData}
 */
export declare const selectData: <TData>(wrapper: IDataWrapper<TData>) => TData;
