"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var definition_1 = require("../../definition");
var ModifyEntityPayloadFactory = /** @class */ (function () {
    function ModifyEntityPayloadFactory() {
    }
    ModifyEntityPayloadFactory_1 = ModifyEntityPayloadFactory;
    /**
     * @stable [09.10.2019]
     * @param {IEffectsAction} action
     * @returns {IModifyEntityPayloadWrapperEntity}
     */
    ModifyEntityPayloadFactory.prototype.makeInstance = function (action) {
        var apiEntity = action.initialData;
        var responseData = action.data;
        var responseEntity = responseData;
        var doesResponseDataNotPrimitiveAndExist = util_1.ifNotNilThanValue(responseData, function () { return !util_1.isPrimitive(responseData); }, false);
        var result = {
            payload: {
                id: doesResponseDataNotPrimitiveAndExist
                    ? responseEntity.id
                    : apiEntity.entityId,
                mergeStrategy: doesResponseDataNotPrimitiveAndExist
                    ? definition_1.EntityMergeStrategiesEnum.OVERRIDE
                    : definition_1.EntityMergeStrategiesEnum.MERGE,
                changes: doesResponseDataNotPrimitiveAndExist
                    ? responseEntity
                    : apiEntity.changes,
            },
        };
        ModifyEntityPayloadFactory_1.logger.debug('[$ModifyEntityPayloadFactory][makeInstance] Payload wrapper:', result, ', action:', action);
        return result;
    };
    var ModifyEntityPayloadFactory_1;
    ModifyEntityPayloadFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('ModifyEntityPayloadFactory');
    ModifyEntityPayloadFactory = ModifyEntityPayloadFactory_1 = __decorate([
        inversify_1.injectable()
    ], ModifyEntityPayloadFactory);
    return ModifyEntityPayloadFactory;
}());
exports.ModifyEntityPayloadFactory = ModifyEntityPayloadFactory;
//# sourceMappingURL=modify-entity-payload.factory.js.map